dnl
dnl  Author: Antonio Carzaniga <carzanig@cs.colorado.edu>
dnl
dnl  Copyright (c) 1999-2000  University of Colorado
dnl
dnl
dnl  This program is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
dnl  USA, or send email to serl@cs.colorado.edu.
dnl 
dnl
dnl $Id: aclocal.m4,v 1.3 2002/12/02 17:39:19 carzanig Exp $
dnl

# Configure paths for GTK+
# Owen Taylor     97-11-3

dnl AM_PATH_GTK([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND [, MODULES]]]])
dnl Test for GTK, and define GTK_CFLAGS and GTK_LIBS
dnl
AC_DEFUN(AM_PATH_GTK,
[dnl 
dnl Get the cflags and libraries from the gtk-config script
dnl
AC_ARG_WITH(gtk-prefix,[  --with-gtk-prefix=PFX   Prefix where GTK is installed (optional)],
            gtk_config_prefix="$withval", gtk_config_prefix="")
AC_ARG_WITH(gtk-exec-prefix,[  --with-gtk-exec-prefix=PFX Exec prefix where GTK is installed (optional)],
            gtk_config_exec_prefix="$withval", gtk_config_exec_prefix="")
AC_ARG_ENABLE(gtktest, [  --disable-gtktest       Do not try to compile and run a test GTK program],
		    , enable_gtktest=yes)

  for module in . $4
  do
      case "$module" in
         gthread) 
             gtk_config_args="$gtk_config_args gthread"
         ;;
      esac
  done

  if test x$gtk_config_exec_prefix != x ; then
     gtk_config_args="$gtk_config_args --exec-prefix=$gtk_config_exec_prefix"
     if test x${GTK_CONFIG+set} != xset ; then
        GTK_CONFIG=$gtk_config_exec_prefix/bin/gtk-config
     fi
  fi
  if test x$gtk_config_prefix != x ; then
     gtk_config_args="$gtk_config_args --prefix=$gtk_config_prefix"
     if test x${GTK_CONFIG+set} != xset ; then
        GTK_CONFIG=$gtk_config_prefix/bin/gtk-config
     fi
  fi

  AC_PATH_PROG(GTK_CONFIG, gtk-config, no)
  min_gtk_version=ifelse([$1], ,0.99.7,$1)
  AC_MSG_CHECKING(for GTK - version >= $min_gtk_version)
  no_gtk=""
  if test "$GTK_CONFIG" = "no" ; then
    no_gtk=yes
  else
    GTK_CFLAGS=`$GTK_CONFIG $gtk_config_args --cflags`
    GTK_LIBS=`$GTK_CONFIG $gtk_config_args --libs`
    gtk_config_major_version=`$GTK_CONFIG $gtk_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    gtk_config_minor_version=`$GTK_CONFIG $gtk_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    gtk_config_micro_version=`$GTK_CONFIG $gtk_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    if test "x$enable_gtktest" = "xyes" ; then
      ac_save_CFLAGS="$CFLAGS"
      ac_save_LIBS="$LIBS"
      CFLAGS="$CFLAGS $GTK_CFLAGS"
      LIBS="$GTK_LIBS $LIBS"
dnl
dnl Now check if the installed GTK is sufficiently new. (Also sanity
dnl checks the results of gtk-config to some extent
dnl
      rm -f conf.gtktest
      AC_TRY_RUN([
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>

int 
main ()
{
  int major, minor, micro;
  char *tmp_version;

  system ("touch conf.gtktest");

  /* HP/UX 9 (%@#!) writes to sscanf strings */
  tmp_version = g_strdup("$min_gtk_version");
  if (sscanf(tmp_version, "%d.%d.%d", &major, &minor, &micro) != 3) {
     printf("%s, bad version string\n", "$min_gtk_version");
     exit(1);
   }

  if ((gtk_major_version != $gtk_config_major_version) ||
      (gtk_minor_version != $gtk_config_minor_version) ||
      (gtk_micro_version != $gtk_config_micro_version))
    {
      printf("\n*** 'gtk-config --version' returned %d.%d.%d, but GTK+ (%d.%d.%d)\n", 
             $gtk_config_major_version, $gtk_config_minor_version, $gtk_config_micro_version,
             gtk_major_version, gtk_minor_version, gtk_micro_version);
      printf ("*** was found! If gtk-config was correct, then it is best\n");
      printf ("*** to remove the old version of GTK+. You may also be able to fix the error\n");
      printf("*** by modifying your LD_LIBRARY_PATH enviroment variable, or by editing\n");
      printf("*** /etc/ld.so.conf. Make sure you have run ldconfig if that is\n");
      printf("*** required on your system.\n");
      printf("*** If gtk-config was wrong, set the environment variable GTK_CONFIG\n");
      printf("*** to point to the correct copy of gtk-config, and remove the file config.cache\n");
      printf("*** before re-running configure\n");
    } 
#if defined (GTK_MAJOR_VERSION) && defined (GTK_MINOR_VERSION) && defined (GTK_MICRO_VERSION)
  else if ((gtk_major_version != GTK_MAJOR_VERSION) ||
	   (gtk_minor_version != GTK_MINOR_VERSION) ||
           (gtk_micro_version != GTK_MICRO_VERSION))
    {
      printf("*** GTK+ header files (version %d.%d.%d) do not match\n",
	     GTK_MAJOR_VERSION, GTK_MINOR_VERSION, GTK_MICRO_VERSION);
      printf("*** library (version %d.%d.%d)\n",
	     gtk_major_version, gtk_minor_version, gtk_micro_version);
    }
#endif /* defined (GTK_MAJOR_VERSION) ... */
  else
    {
      if ((gtk_major_version > major) ||
        ((gtk_major_version == major) && (gtk_minor_version > minor)) ||
        ((gtk_major_version == major) && (gtk_minor_version == minor) && (gtk_micro_version >= micro)))
      {
        return 0;
       }
     else
      {
        printf("\n*** An old version of GTK+ (%d.%d.%d) was found.\n",
               gtk_major_version, gtk_minor_version, gtk_micro_version);
        printf("*** You need a version of GTK+ newer than %d.%d.%d. The latest version of\n",
	       major, minor, micro);
        printf("*** GTK+ is always available from ftp://ftp.gtk.org.\n");
        printf("***\n");
        printf("*** If you have already installed a sufficiently new version, this error\n");
        printf("*** probably means that the wrong copy of the gtk-config shell script is\n");
        printf("*** being found. The easiest way to fix this is to remove the old version\n");
        printf("*** of GTK+, but you can also set the GTK_CONFIG environment to point to the\n");
        printf("*** correct copy of gtk-config. (In this case, you will have to\n");
        printf("*** modify your LD_LIBRARY_PATH enviroment variable, or edit /etc/ld.so.conf\n");
        printf("*** so that the correct libraries are found at run-time))\n");
      }
    }
  return 1;
}
],, no_gtk=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
     fi
  fi
  if test "x$no_gtk" = x ; then
     AC_MSG_RESULT(yes)
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$GTK_CONFIG" = "no" ; then
       echo "*** The gtk-config script installed by GTK could not be found"
       echo "*** If GTK was installed in PREFIX, make sure PREFIX/bin is in"
       echo "*** your path, or set the GTK_CONFIG environment variable to the"
       echo "*** full path to gtk-config."
     else
       if test -f conf.gtktest ; then
        :
       else
          echo "*** Could not run GTK test program, checking why..."
          CFLAGS="$CFLAGS $GTK_CFLAGS"
          LIBS="$LIBS $GTK_LIBS"
          AC_TRY_LINK([
#include <gtk/gtk.h>
#include <stdio.h>
],      [ return ((gtk_major_version) || (gtk_minor_version) || (gtk_micro_version)); ],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding GTK or finding the wrong"
          echo "*** version of GTK. If it is not finding GTK, you'll need to set your"
          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
          echo "*** is required on your system"
	  echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH"
          echo "***"
          echo "*** If you have a RedHat 5.0 system, you should remove the GTK package that"
          echo "*** came with the system with the command"
          echo "***"
          echo "***    rpm --erase --nodeps gtk gtk-devel" ],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means GTK was incorrectly installed"
          echo "*** or that you have moved GTK since it was installed. In the latter case, you"
          echo "*** may want to edit the gtk-config script: $GTK_CONFIG" ])
          CFLAGS="$ac_save_CFLAGS"
          LIBS="$ac_save_LIBS"
       fi
     fi
     GTK_CFLAGS=""
     GTK_LIBS=""
     ifelse([$3], , :, [$3])
  fi
  AC_SUBST(GTK_CFLAGS)
  AC_SUBST(GTK_LIBS)
  rm -f conf.gtktest
])

dnl
dnl AC_ANTO_SEARCH_LIBS(FUNCTION, SEARCH-LIBS [, ACTION-IF-FOUND
dnl                     [, ACTION-IF-NOT-FOUND [, OTHER-LIBRARIES]]])
dnl
dnl Search for a library defining FUNC, if it's not already available.
dnl
dnl I'm redefining this Autoconf macro to force it to use my own 
dnl AC_ANTO_TRY_LINK_FUNC instead of AC_TRY_LINK_FUNC
dnl
AC_DEFUN(AC_ANTO_SEARCH_LIBS, [
  AC_CACHE_CHECK([for library containing $1], [ac_cv_search_$1], [
    ac_func_search_save_LIBS="$LIBS"
    ac_cv_search_$1="no"
    AC_ANTO_TRY_LINK_FUNC([$1], [ac_cv_search_$1="none required"])
    test "$ac_cv_search_$1" = "no" && for i in $2; do
      LIBS="-l$i $5 $ac_func_search_save_LIBS"
      AC_ANTO_TRY_LINK_FUNC([$1], [
        ac_cv_search_$1="-l$i"
        break])
      done
    LIBS="$ac_func_search_save_LIBS"])
  if test "$ac_cv_search_$1" != "no"; then
    test "$ac_cv_search_$1" = "none required" || LIBS="$ac_cv_search_$1 $LIBS"
    $3
  else :
    $4
  fi])

dnl 
dnl  AC_ANTO_CXX_NAMESPACES([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl 
dnl  checks whether CXX implements namespaces
dnl 
AC_DEFUN(AC_ANTO_CXX_NAMESPACES,[
  AC_CACHE_CHECK([whether c++ implements namespaces], 
     ac_cv_anto_cxx_namespaces, 
     AC_TRY_COMPILE([
       namespace Outer { namespace Inner { int i = 0; }}
      ], [
       using namespace Outer::Inner; return i;
      ], ac_cv_anto_cxx_namespaces=yes, ac_cv_anto_cxx_namespaces=no))
  if test "$ac_cv_cxx_namespaces" = yes; then
    AC_DEFINE(HAVE_CXX_NAMESPACE)
    $1
  else :
    $2
  fi])

dnl 
dnl  AC_ANTO_CXX_EXCEPTIONS([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl 
dnl  checks whether CXX implements exceptions
dnl 
AC_DEFUN(AC_ANTO_CXX_EXCEPTIONS,[
  AC_CACHE_CHECK([whether c++ implements exceptions], 
    ac_cv_anto_cxx_exceptions,
    AC_TRY_COMPILE([
      #include <exception>
      ], [
      try {
 	  int x;
       } catch (exception &ex) {
          throw;
       }
      ], ac_cv_anto_cxx_exceptions=yes, ac_cv_anto_cxx_exceptions=no))
  if test "$ac_cv_cxx_namespaces" = yes; then
    AC_DEFINE(HAVE_CXX_EXCEPTIONS)
    $1
  else :
    $2
  fi])

dnl
dnl  AC_ANTO_TYPE(TYPE, DEFAULT, [,EXTRA-INCLUDES])
dnl
dnl  looks for the specific type in network includes
dnl
AC_DEFUN(AC_ANTO_TYPE, [
  AC_CACHE_CHECK([for $1], ac_cv_anto_type_$1,
    AC_TRY_COMPILE([
#     include <sys/types.h> 
      ][
$3
      ], [
      $1 x;
      ], ac_cv_anto_type_$1=yes, ac_cv_anto_type_$1=no))
  if test $ac_cv_anto_type_$1 = no; then
    AC_DEFINE($1,$2)
  fi])

dnl 
dnl  check for MAXHOSTNAMELEN
dnl 
AC_DEFUN(AC_ANTO_MAXHOSTNAMELEN, [
  AC_CACHE_CHECK([for MAXHOSTNAMELEN], ac_cv_anto_maxhostnamelen, 
    AC_TRY_COMPILE([
#     include <netdb.h>
#     include <sys/param.h>], [int i = MAXHOSTNAMELEN;] , 
      ac_cv_anto_maxhostnamelen=yes, ac_cv_anto_maxhostnamelen=no))
  if test $ac_cv_anto_maxhostnamelen = no; then 
    AC_DEFINE(MAXHOSTNAMELEN, 256)
  fi])


dnl 
dnl  check for TIOCNOTTY
dnl 
AC_DEFUN(AC_ANTO_TIOCNOTTY, [
  AC_CACHE_CHECK([for TIOCNOTTY], ac_cv_anto_macro_tiocnotty, 
    AC_TRY_COMPILE([
      #include <termios.h>], [
      int i = TIOCNOTTY; ], 
      ac_cv_anto_macro_tiocnotty=yes, ac_cv_anto_macro_tiocnotty=no))
  if test $ac_cv_anto_macro_tiocnotty = yes; then
     AC_DEFINE(HAVE_TIOCNOTTY)
  fi])

dnl
dnl  AC_ANTO_LIBPAR(LIBRARY [, DEFAULTBASE])
dnl
AC_DEFUN(AC_ANTO_LIBPAR, 
  ifelse([$2], , [
  $1_include="$2/include"
  $1_libdir="$2/lib"
  ], )[
  AC_ARG_WITH($1-root,
    [  --with-$1-root=dir  finds $1 root dir], 
    [ $1_include="-I$withval/include"
      $1_libdir="-L$withval/lib" ])
  AC_ARG_WITH($1-include,
    [  --with-$1-include=dir  finds $1 includes in dir], 
    $1_include="-I$withval")
  AC_ARG_WITH($1-libdir,
    [  --with-$1-libdir=dir  finds $1 libraries in dir], 
    $1_libdir="-L$withval")
  test -z "$$1_libs" && $1_libs="-l$1"
  AC_ARG_WITH($1-libs,
    [  --with-$1-libs=libraries  $1 libraries (default=-l$1)], 
    $1_libs="$withval")])

dnl
dnl  AC_ANTO_SAVEFLAGS(LIBRARY)
dnl
AC_DEFUN(AC_ANTO_SAVEFLAGS, [
  CFLAGS_before_$1="$CFALGS"
  CFLAGS="$$1_include $CFLAGS"
  CXXFLAGS_before_$1="$CXXFALGS"
  CXXFLAGS="$$1_include $CXXFLAGS"
  LDFLAGS_before_$1="$LDFLAGS"
  LDFLAGS="$$1_libdir $LDFLAGS"
  LIBS_before_$1="$LIBS"
  LIBS="$$1_libs $LIBS"
])

dnl
dnl  AC_ANTO_RESTOREFLAGS(LIBRARY)
dnl
AC_DEFUN(AC_ANTO_RESTOREFLAGS, [
  CFLAGS="$CFLAGS_before_$1"
  CXXFLAGS="$CXXFLAGS_before_$1"
  LDFLAGS="$LDFLAGS_before_$1"
  LIBS="$LIBS_before_$1"
])

dnl
dnl  AC_ANTO_PTHREAD_RWLOCK([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl
dnl  check for pthread read/write locks
dnl 
AC_DEFUN(AC_ANTO_PTHREAD_RWLOCK, [
  AC_CACHE_CHECK([for pthread_rwlock], ac_cv_anto_pthread_rwlock,
  AC_TRY_COMPILE([
      #include <pthread.h>
    ], [
      pthread_rwlock_t l;
      pthread_rwlock_init(&l, NULL);
    ], ac_cv_anto_pthread_rwlock=yes, ac_cv_anto_pthread_rwlock=no))
    if test $ac_cv_anto_pthread_rwlock = yes; then
      AC_DEFINE(HAVE_PTHREAD_RWLOCK)
      $1
    else :
      $2
    fi])

dnl
dnl  AC_ANTO_PTHREAD_YIELD([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl
dnl  check for pthread read/write locks
dnl 
AC_DEFUN(AC_ANTO_PTHREAD_YIELD, [
  AC_CACHE_CHECK([for pthread_yield], ac_cv_anto_pthread_yield,
  AC_TRY_LINK([
      #include <pthread.h>
    ], [
      pthread_yield();
    ], ac_cv_anto_pthread_yield=yes, ac_cv_anto_pthread_yield=no))
    if test $ac_cv_anto_pthread_yield = yes; then
      AC_DEFINE(HAVE_PTHREAD_YIELD)
      $1
    else :
      $2
    fi])

dnl
dnl  AC_ANTO_PTHREADS([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl
dnl  check for POSIX threads
dnl 
AC_DEFUN(AC_ANTO_PTHREADS, [
  AC_ANTO_LIBPAR(pthread)
  AC_ANTO_SAVEFLAGS(pthread)
  #
  # look for POSIX threads
  # 
  AC_CACHE_CHECK([for POSIX 1.c threads], ac_cv_anto_pthread, 
    AC_TRY_LINK([
      #include <pthread.h>
      ], [
      pthread_create(0,0,0,0); pthread_attr_init(NULL);], 
      ac_cv_anto_pthread=yes, [
      LDFLAGS="-pthread $LDFLAGS"
	AC_TRY_LINK([
        #include <pthread.h>
        ], [
        pthread_create(0,0,0,0); 
        pthread_attr_init(NULL);
        ], [
        ac_cv_anto_pthread=yes
        pthread_libdir="-pthread $pthread_libdir"
        ], ac_cv_anto_pthread=no)]))
    if test $ac_cv_anto_pthread = yes; then
      AC_DEFINE(HAVE_PTHREADS)
      $1
    else :
      pthread_include=""
      pthread_libdir=""
      pthread_libs=""
      $2
    fi
    AC_ANTO_RESTOREFLAGS(pthread)
    AC_SUBST(pthread_include)
    AC_SUBST(pthread_libs)
    AC_SUBST(pthread_libdir)])

dnl 
dnl  AC_ANTO_GDBM([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl
dnl  check for gdbm
dnl 
AC_DEFUN(AC_ANTO_GDBM, [
  AC_ANTO_LIBPAR(gdbm)
  AC_ANTO_SAVEFLAGS(gdbm)
  AC_CACHE_CHECK([for gdbm library], ac_cv_anto_gdbm, 
    AC_TRY_LINK([
      #include <fcntl.h>
      #include <gdbm.h>], [
      GDBM_FILE   db;
      db =  gdbm_open("test", 0, O_RDWR | O_CREAT, 0600, (void (*)(...))0);], 
      ac_cv_anto_gdbm=yes, ac_cv_anto_gdbm=no))
  if test $ac_cv_anto_gdbm = yes; then
     AC_DEFINE(HAVE_GDBM)
     $1
  else :
     $2
  fi
  AC_ANTO_RESTOREFLAGS(gdbm)
  AC_SUBST(gdbm_include)
  AC_SUBST(gdbm_libs)
  AC_SUBST(gdbm_libdir)])

AC_DEFUN(AC_ANTO_SIENA, [

  siena_libs="-lsiena"
  AC_ANTO_LIBPAR(siena)
  AC_ANTO_SAVEFLAGS(siena)
  AC_CACHE_CHECK([for Siena], ac_cv_anto_siena, 
    AC_TRY_LINK([
         #include <siena/Siena.h>
         #include <siena/Monitor.h>
      ], [
         Event e; Filter f;
         Monitor * m = new SimpleMonitor("localhost", 1234);
      ], ac_cv_anto_siena=yes, ac_cv_anto_siena=no))
    if test $ac_cv_anto_siena = yes; then
      AC_DEFINE(HAVE_SIENA)
      $1
    else :
      siena_include=""
      siena_libdir=""
      siena_libs=""
      $2
    fi
    AC_SUBST(siena_include)
    AC_SUBST(siena_libs)
    AC_SUBST(siena_libdir)
    AC_ANTO_RESTOREFLAGS(siena)])

dnl  
dnl  AC_ANTO_MKPATH([ACTION-IF-NOT-FOUND][, ACTION-IF-NOT-FOUND])
dnl
dnl  check for a way to create an entire directory path 
dnl  tries `mkdir -p' and `$srcdir/mkinstalldirs'
dnl 
AC_DEFUN(AC_ANTO_MKPATH, [
  AC_CACHE_CHECK([how to create a directory path], ac_cv_anto_mkpath, [
    anto_td=_test_anto
    # paranoia...
    while test -r $anto_td; do anto_td="$anto_td."; done
    ac_cv_anto_mkpath=no
    if mkdir -p $anto_td/1/2 > /dev/null 2>&1 && test -d $anto_td/1/2; then
      /bin/rm -rf $anto_td
      ac_cv_anto_mkpath="mkdir -p"
    elif $srcdir/mkinstalldirs $anto_td/1/2 > /dev/null 2>&1 && test -d $anto_td/1/2; then
      ac_cv_anto_mkpath=\$\(srcdir\)/mkinstalldirs
    else
      ac_cv_anto_mkpath=no
    fi])
  if test "$ac_cv_anto_mkpath" = no; then
    MKPATH=""
    : 
    $1
  else
    MKPATH="$ac_cv_anto_mkpath"
    AC_SUBST(MKPATH)
    :
    $2
  fi])
